package com.dhcc.finance.main.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CwHsGlorgbookExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CwHsGlorgbookExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("ID like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("ID not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andGlorgbookCodeIsNull() {
            addCriterion("GLORGBOOK_CODE is null");
            return (Criteria) this;
        }

        public Criteria andGlorgbookCodeIsNotNull() {
            addCriterion("GLORGBOOK_CODE is not null");
            return (Criteria) this;
        }

        public Criteria andGlorgbookCodeEqualTo(String value) {
            addCriterion("GLORGBOOK_CODE =", value, "glorgbookCode");
            return (Criteria) this;
        }

        public Criteria andGlorgbookCodeNotEqualTo(String value) {
            addCriterion("GLORGBOOK_CODE <>", value, "glorgbookCode");
            return (Criteria) this;
        }

        public Criteria andGlorgbookCodeGreaterThan(String value) {
            addCriterion("GLORGBOOK_CODE >", value, "glorgbookCode");
            return (Criteria) this;
        }

        public Criteria andGlorgbookCodeGreaterThanOrEqualTo(String value) {
            addCriterion("GLORGBOOK_CODE >=", value, "glorgbookCode");
            return (Criteria) this;
        }

        public Criteria andGlorgbookCodeLessThan(String value) {
            addCriterion("GLORGBOOK_CODE <", value, "glorgbookCode");
            return (Criteria) this;
        }

        public Criteria andGlorgbookCodeLessThanOrEqualTo(String value) {
            addCriterion("GLORGBOOK_CODE <=", value, "glorgbookCode");
            return (Criteria) this;
        }

        public Criteria andGlorgbookCodeLike(String value) {
            addCriterion("GLORGBOOK_CODE like", value, "glorgbookCode");
            return (Criteria) this;
        }

        public Criteria andGlorgbookCodeNotLike(String value) {
            addCriterion("GLORGBOOK_CODE not like", value, "glorgbookCode");
            return (Criteria) this;
        }

        public Criteria andGlorgbookCodeIn(List<String> values) {
            addCriterion("GLORGBOOK_CODE in", values, "glorgbookCode");
            return (Criteria) this;
        }

        public Criteria andGlorgbookCodeNotIn(List<String> values) {
            addCriterion("GLORGBOOK_CODE not in", values, "glorgbookCode");
            return (Criteria) this;
        }

        public Criteria andGlorgbookCodeBetween(String value1, String value2) {
            addCriterion("GLORGBOOK_CODE between", value1, value2, "glorgbookCode");
            return (Criteria) this;
        }

        public Criteria andGlorgbookCodeNotBetween(String value1, String value2) {
            addCriterion("GLORGBOOK_CODE not between", value1, value2, "glorgbookCode");
            return (Criteria) this;
        }

        public Criteria andGlorgbookNameIsNull() {
            addCriterion("GLORGBOOK_NAME is null");
            return (Criteria) this;
        }

        public Criteria andGlorgbookNameIsNotNull() {
            addCriterion("GLORGBOOK_NAME is not null");
            return (Criteria) this;
        }

        public Criteria andGlorgbookNameEqualTo(String value) {
            addCriterion("GLORGBOOK_NAME =", value, "glorgbookName");
            return (Criteria) this;
        }

        public Criteria andGlorgbookNameNotEqualTo(String value) {
            addCriterion("GLORGBOOK_NAME <>", value, "glorgbookName");
            return (Criteria) this;
        }

        public Criteria andGlorgbookNameGreaterThan(String value) {
            addCriterion("GLORGBOOK_NAME >", value, "glorgbookName");
            return (Criteria) this;
        }

        public Criteria andGlorgbookNameGreaterThanOrEqualTo(String value) {
            addCriterion("GLORGBOOK_NAME >=", value, "glorgbookName");
            return (Criteria) this;
        }

        public Criteria andGlorgbookNameLessThan(String value) {
            addCriterion("GLORGBOOK_NAME <", value, "glorgbookName");
            return (Criteria) this;
        }

        public Criteria andGlorgbookNameLessThanOrEqualTo(String value) {
            addCriterion("GLORGBOOK_NAME <=", value, "glorgbookName");
            return (Criteria) this;
        }

        public Criteria andGlorgbookNameLike(String value) {
            addCriterion("GLORGBOOK_NAME like", value, "glorgbookName");
            return (Criteria) this;
        }

        public Criteria andGlorgbookNameNotLike(String value) {
            addCriterion("GLORGBOOK_NAME not like", value, "glorgbookName");
            return (Criteria) this;
        }

        public Criteria andGlorgbookNameIn(List<String> values) {
            addCriterion("GLORGBOOK_NAME in", values, "glorgbookName");
            return (Criteria) this;
        }

        public Criteria andGlorgbookNameNotIn(List<String> values) {
            addCriterion("GLORGBOOK_NAME not in", values, "glorgbookName");
            return (Criteria) this;
        }

        public Criteria andGlorgbookNameBetween(String value1, String value2) {
            addCriterion("GLORGBOOK_NAME between", value1, value2, "glorgbookName");
            return (Criteria) this;
        }

        public Criteria andGlorgbookNameNotBetween(String value1, String value2) {
            addCriterion("GLORGBOOK_NAME not between", value1, value2, "glorgbookName");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagIsNull() {
            addCriterion("COMPANY_FLAG is null");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagIsNotNull() {
            addCriterion("COMPANY_FLAG is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagEqualTo(String value) {
            addCriterion("COMPANY_FLAG =", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagNotEqualTo(String value) {
            addCriterion("COMPANY_FLAG <>", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagGreaterThan(String value) {
            addCriterion("COMPANY_FLAG >", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagGreaterThanOrEqualTo(String value) {
            addCriterion("COMPANY_FLAG >=", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagLessThan(String value) {
            addCriterion("COMPANY_FLAG <", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagLessThanOrEqualTo(String value) {
            addCriterion("COMPANY_FLAG <=", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagLike(String value) {
            addCriterion("COMPANY_FLAG like", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagNotLike(String value) {
            addCriterion("COMPANY_FLAG not like", value, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagIn(List<String> values) {
            addCriterion("COMPANY_FLAG in", values, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagNotIn(List<String> values) {
            addCriterion("COMPANY_FLAG not in", values, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagBetween(String value1, String value2) {
            addCriterion("COMPANY_FLAG between", value1, value2, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andCompanyFlagNotBetween(String value1, String value2) {
            addCriterion("COMPANY_FLAG not between", value1, value2, "companyFlag");
            return (Criteria) this;
        }

        public Criteria andStartDateIsNull() {
            addCriterion("START_DATE is null");
            return (Criteria) this;
        }

        public Criteria andStartDateIsNotNull() {
            addCriterion("START_DATE is not null");
            return (Criteria) this;
        }

        public Criteria andStartDateEqualTo(String value) {
            addCriterion("START_DATE =", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotEqualTo(String value) {
            addCriterion("START_DATE <>", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateGreaterThan(String value) {
            addCriterion("START_DATE >", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateGreaterThanOrEqualTo(String value) {
            addCriterion("START_DATE >=", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateLessThan(String value) {
            addCriterion("START_DATE <", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateLessThanOrEqualTo(String value) {
            addCriterion("START_DATE <=", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateLike(String value) {
            addCriterion("START_DATE like", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotLike(String value) {
            addCriterion("START_DATE not like", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateIn(List<String> values) {
            addCriterion("START_DATE in", values, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotIn(List<String> values) {
            addCriterion("START_DATE not in", values, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateBetween(String value1, String value2) {
            addCriterion("START_DATE between", value1, value2, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotBetween(String value1, String value2) {
            addCriterion("START_DATE not between", value1, value2, "startDate");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNull() {
            addCriterion("END_DATE is null");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNotNull() {
            addCriterion("END_DATE is not null");
            return (Criteria) this;
        }

        public Criteria andEndDateEqualTo(String value) {
            addCriterion("END_DATE =", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotEqualTo(String value) {
            addCriterion("END_DATE <>", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThan(String value) {
            addCriterion("END_DATE >", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThanOrEqualTo(String value) {
            addCriterion("END_DATE >=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThan(String value) {
            addCriterion("END_DATE <", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThanOrEqualTo(String value) {
            addCriterion("END_DATE <=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLike(String value) {
            addCriterion("END_DATE like", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotLike(String value) {
            addCriterion("END_DATE not like", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateIn(List<String> values) {
            addCriterion("END_DATE in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotIn(List<String> values) {
            addCriterion("END_DATE not in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateBetween(String value1, String value2) {
            addCriterion("END_DATE between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotBetween(String value1, String value2) {
            addCriterion("END_DATE not between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andProductIdIsNull() {
            addCriterion("PRODUCT_ID is null");
            return (Criteria) this;
        }

        public Criteria andProductIdIsNotNull() {
            addCriterion("PRODUCT_ID is not null");
            return (Criteria) this;
        }

        public Criteria andProductIdEqualTo(String value) {
            addCriterion("PRODUCT_ID =", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdNotEqualTo(String value) {
            addCriterion("PRODUCT_ID <>", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdGreaterThan(String value) {
            addCriterion("PRODUCT_ID >", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdGreaterThanOrEqualTo(String value) {
            addCriterion("PRODUCT_ID >=", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdLessThan(String value) {
            addCriterion("PRODUCT_ID <", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdLessThanOrEqualTo(String value) {
            addCriterion("PRODUCT_ID <=", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdLike(String value) {
            addCriterion("PRODUCT_ID like", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdNotLike(String value) {
            addCriterion("PRODUCT_ID not like", value, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdIn(List<String> values) {
            addCriterion("PRODUCT_ID in", values, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdNotIn(List<String> values) {
            addCriterion("PRODUCT_ID not in", values, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdBetween(String value1, String value2) {
            addCriterion("PRODUCT_ID between", value1, value2, "productId");
            return (Criteria) this;
        }

        public Criteria andProductIdNotBetween(String value1, String value2) {
            addCriterion("PRODUCT_ID not between", value1, value2, "productId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdIsNull() {
            addCriterion("SUB_PRODUCT_ID is null");
            return (Criteria) this;
        }

        public Criteria andSubProductIdIsNotNull() {
            addCriterion("SUB_PRODUCT_ID is not null");
            return (Criteria) this;
        }

        public Criteria andSubProductIdEqualTo(String value) {
            addCriterion("SUB_PRODUCT_ID =", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdNotEqualTo(String value) {
            addCriterion("SUB_PRODUCT_ID <>", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdGreaterThan(String value) {
            addCriterion("SUB_PRODUCT_ID >", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdGreaterThanOrEqualTo(String value) {
            addCriterion("SUB_PRODUCT_ID >=", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdLessThan(String value) {
            addCriterion("SUB_PRODUCT_ID <", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdLessThanOrEqualTo(String value) {
            addCriterion("SUB_PRODUCT_ID <=", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdLike(String value) {
            addCriterion("SUB_PRODUCT_ID like", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdNotLike(String value) {
            addCriterion("SUB_PRODUCT_ID not like", value, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdIn(List<String> values) {
            addCriterion("SUB_PRODUCT_ID in", values, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdNotIn(List<String> values) {
            addCriterion("SUB_PRODUCT_ID not in", values, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdBetween(String value1, String value2) {
            addCriterion("SUB_PRODUCT_ID between", value1, value2, "subProductId");
            return (Criteria) this;
        }

        public Criteria andSubProductIdNotBetween(String value1, String value2) {
            addCriterion("SUB_PRODUCT_ID not between", value1, value2, "subProductId");
            return (Criteria) this;
        }

        public Criteria andDfCompanyIsNull() {
            addCriterion("DF_COMPANY is null");
            return (Criteria) this;
        }

        public Criteria andDfCompanyIsNotNull() {
            addCriterion("DF_COMPANY is not null");
            return (Criteria) this;
        }

        public Criteria andDfCompanyEqualTo(String value) {
            addCriterion("DF_COMPANY =", value, "dfCompany");
            return (Criteria) this;
        }

        public Criteria andDfCompanyNotEqualTo(String value) {
            addCriterion("DF_COMPANY <>", value, "dfCompany");
            return (Criteria) this;
        }

        public Criteria andDfCompanyGreaterThan(String value) {
            addCriterion("DF_COMPANY >", value, "dfCompany");
            return (Criteria) this;
        }

        public Criteria andDfCompanyGreaterThanOrEqualTo(String value) {
            addCriterion("DF_COMPANY >=", value, "dfCompany");
            return (Criteria) this;
        }

        public Criteria andDfCompanyLessThan(String value) {
            addCriterion("DF_COMPANY <", value, "dfCompany");
            return (Criteria) this;
        }

        public Criteria andDfCompanyLessThanOrEqualTo(String value) {
            addCriterion("DF_COMPANY <=", value, "dfCompany");
            return (Criteria) this;
        }

        public Criteria andDfCompanyLike(String value) {
            addCriterion("DF_COMPANY like", value, "dfCompany");
            return (Criteria) this;
        }

        public Criteria andDfCompanyNotLike(String value) {
            addCriterion("DF_COMPANY not like", value, "dfCompany");
            return (Criteria) this;
        }

        public Criteria andDfCompanyIn(List<String> values) {
            addCriterion("DF_COMPANY in", values, "dfCompany");
            return (Criteria) this;
        }

        public Criteria andDfCompanyNotIn(List<String> values) {
            addCriterion("DF_COMPANY not in", values, "dfCompany");
            return (Criteria) this;
        }

        public Criteria andDfCompanyBetween(String value1, String value2) {
            addCriterion("DF_COMPANY between", value1, value2, "dfCompany");
            return (Criteria) this;
        }

        public Criteria andDfCompanyNotBetween(String value1, String value2) {
            addCriterion("DF_COMPANY not between", value1, value2, "dfCompany");
            return (Criteria) this;
        }

        public Criteria andMapFlagIsNull() {
            addCriterion("MAP_FLAG is null");
            return (Criteria) this;
        }

        public Criteria andMapFlagIsNotNull() {
            addCriterion("MAP_FLAG is not null");
            return (Criteria) this;
        }

        public Criteria andMapFlagEqualTo(String value) {
            addCriterion("MAP_FLAG =", value, "mapFlag");
            return (Criteria) this;
        }

        public Criteria andMapFlagNotEqualTo(String value) {
            addCriterion("MAP_FLAG <>", value, "mapFlag");
            return (Criteria) this;
        }

        public Criteria andMapFlagGreaterThan(String value) {
            addCriterion("MAP_FLAG >", value, "mapFlag");
            return (Criteria) this;
        }

        public Criteria andMapFlagGreaterThanOrEqualTo(String value) {
            addCriterion("MAP_FLAG >=", value, "mapFlag");
            return (Criteria) this;
        }

        public Criteria andMapFlagLessThan(String value) {
            addCriterion("MAP_FLAG <", value, "mapFlag");
            return (Criteria) this;
        }

        public Criteria andMapFlagLessThanOrEqualTo(String value) {
            addCriterion("MAP_FLAG <=", value, "mapFlag");
            return (Criteria) this;
        }

        public Criteria andMapFlagLike(String value) {
            addCriterion("MAP_FLAG like", value, "mapFlag");
            return (Criteria) this;
        }

        public Criteria andMapFlagNotLike(String value) {
            addCriterion("MAP_FLAG not like", value, "mapFlag");
            return (Criteria) this;
        }

        public Criteria andMapFlagIn(List<String> values) {
            addCriterion("MAP_FLAG in", values, "mapFlag");
            return (Criteria) this;
        }

        public Criteria andMapFlagNotIn(List<String> values) {
            addCriterion("MAP_FLAG not in", values, "mapFlag");
            return (Criteria) this;
        }

        public Criteria andMapFlagBetween(String value1, String value2) {
            addCriterion("MAP_FLAG between", value1, value2, "mapFlag");
            return (Criteria) this;
        }

        public Criteria andMapFlagNotBetween(String value1, String value2) {
            addCriterion("MAP_FLAG not between", value1, value2, "mapFlag");
            return (Criteria) this;
        }

        public Criteria andImportModeIsNull() {
            addCriterion("IMPORT_MODE is null");
            return (Criteria) this;
        }

        public Criteria andImportModeIsNotNull() {
            addCriterion("IMPORT_MODE is not null");
            return (Criteria) this;
        }

        public Criteria andImportModeEqualTo(String value) {
            addCriterion("IMPORT_MODE =", value, "importMode");
            return (Criteria) this;
        }

        public Criteria andImportModeNotEqualTo(String value) {
            addCriterion("IMPORT_MODE <>", value, "importMode");
            return (Criteria) this;
        }

        public Criteria andImportModeGreaterThan(String value) {
            addCriterion("IMPORT_MODE >", value, "importMode");
            return (Criteria) this;
        }

        public Criteria andImportModeGreaterThanOrEqualTo(String value) {
            addCriterion("IMPORT_MODE >=", value, "importMode");
            return (Criteria) this;
        }

        public Criteria andImportModeLessThan(String value) {
            addCriterion("IMPORT_MODE <", value, "importMode");
            return (Criteria) this;
        }

        public Criteria andImportModeLessThanOrEqualTo(String value) {
            addCriterion("IMPORT_MODE <=", value, "importMode");
            return (Criteria) this;
        }

        public Criteria andImportModeLike(String value) {
            addCriterion("IMPORT_MODE like", value, "importMode");
            return (Criteria) this;
        }

        public Criteria andImportModeNotLike(String value) {
            addCriterion("IMPORT_MODE not like", value, "importMode");
            return (Criteria) this;
        }

        public Criteria andImportModeIn(List<String> values) {
            addCriterion("IMPORT_MODE in", values, "importMode");
            return (Criteria) this;
        }

        public Criteria andImportModeNotIn(List<String> values) {
            addCriterion("IMPORT_MODE not in", values, "importMode");
            return (Criteria) this;
        }

        public Criteria andImportModeBetween(String value1, String value2) {
            addCriterion("IMPORT_MODE between", value1, value2, "importMode");
            return (Criteria) this;
        }

        public Criteria andImportModeNotBetween(String value1, String value2) {
            addCriterion("IMPORT_MODE not between", value1, value2, "importMode");
            return (Criteria) this;
        }

        public Criteria andLastDateIsNull() {
            addCriterion("LAST_DATE is null");
            return (Criteria) this;
        }

        public Criteria andLastDateIsNotNull() {
            addCriterion("LAST_DATE is not null");
            return (Criteria) this;
        }

        public Criteria andLastDateEqualTo(String value) {
            addCriterion("LAST_DATE =", value, "lastDate");
            return (Criteria) this;
        }

        public Criteria andLastDateNotEqualTo(String value) {
            addCriterion("LAST_DATE <>", value, "lastDate");
            return (Criteria) this;
        }

        public Criteria andLastDateGreaterThan(String value) {
            addCriterion("LAST_DATE >", value, "lastDate");
            return (Criteria) this;
        }

        public Criteria andLastDateGreaterThanOrEqualTo(String value) {
            addCriterion("LAST_DATE >=", value, "lastDate");
            return (Criteria) this;
        }

        public Criteria andLastDateLessThan(String value) {
            addCriterion("LAST_DATE <", value, "lastDate");
            return (Criteria) this;
        }

        public Criteria andLastDateLessThanOrEqualTo(String value) {
            addCriterion("LAST_DATE <=", value, "lastDate");
            return (Criteria) this;
        }

        public Criteria andLastDateLike(String value) {
            addCriterion("LAST_DATE like", value, "lastDate");
            return (Criteria) this;
        }

        public Criteria andLastDateNotLike(String value) {
            addCriterion("LAST_DATE not like", value, "lastDate");
            return (Criteria) this;
        }

        public Criteria andLastDateIn(List<String> values) {
            addCriterion("LAST_DATE in", values, "lastDate");
            return (Criteria) this;
        }

        public Criteria andLastDateNotIn(List<String> values) {
            addCriterion("LAST_DATE not in", values, "lastDate");
            return (Criteria) this;
        }

        public Criteria andLastDateBetween(String value1, String value2) {
            addCriterion("LAST_DATE between", value1, value2, "lastDate");
            return (Criteria) this;
        }

        public Criteria andLastDateNotBetween(String value1, String value2) {
            addCriterion("LAST_DATE not between", value1, value2, "lastDate");
            return (Criteria) this;
        }

        public Criteria andInputManIsNull() {
            addCriterion("INPUT_MAN is null");
            return (Criteria) this;
        }

        public Criteria andInputManIsNotNull() {
            addCriterion("INPUT_MAN is not null");
            return (Criteria) this;
        }

        public Criteria andInputManEqualTo(String value) {
            addCriterion("INPUT_MAN =", value, "inputMan");
            return (Criteria) this;
        }

        public Criteria andInputManNotEqualTo(String value) {
            addCriterion("INPUT_MAN <>", value, "inputMan");
            return (Criteria) this;
        }

        public Criteria andInputManGreaterThan(String value) {
            addCriterion("INPUT_MAN >", value, "inputMan");
            return (Criteria) this;
        }

        public Criteria andInputManGreaterThanOrEqualTo(String value) {
            addCriterion("INPUT_MAN >=", value, "inputMan");
            return (Criteria) this;
        }

        public Criteria andInputManLessThan(String value) {
            addCriterion("INPUT_MAN <", value, "inputMan");
            return (Criteria) this;
        }

        public Criteria andInputManLessThanOrEqualTo(String value) {
            addCriterion("INPUT_MAN <=", value, "inputMan");
            return (Criteria) this;
        }

        public Criteria andInputManLike(String value) {
            addCriterion("INPUT_MAN like", value, "inputMan");
            return (Criteria) this;
        }

        public Criteria andInputManNotLike(String value) {
            addCriterion("INPUT_MAN not like", value, "inputMan");
            return (Criteria) this;
        }

        public Criteria andInputManIn(List<String> values) {
            addCriterion("INPUT_MAN in", values, "inputMan");
            return (Criteria) this;
        }

        public Criteria andInputManNotIn(List<String> values) {
            addCriterion("INPUT_MAN not in", values, "inputMan");
            return (Criteria) this;
        }

        public Criteria andInputManBetween(String value1, String value2) {
            addCriterion("INPUT_MAN between", value1, value2, "inputMan");
            return (Criteria) this;
        }

        public Criteria andInputManNotBetween(String value1, String value2) {
            addCriterion("INPUT_MAN not between", value1, value2, "inputMan");
            return (Criteria) this;
        }

        public Criteria andInputTimeIsNull() {
            addCriterion("INPUT_TIME is null");
            return (Criteria) this;
        }

        public Criteria andInputTimeIsNotNull() {
            addCriterion("INPUT_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andInputTimeEqualTo(Date value) {
            addCriterion("INPUT_TIME =", value, "inputTime");
            return (Criteria) this;
        }

        public Criteria andInputTimeNotEqualTo(Date value) {
            addCriterion("INPUT_TIME <>", value, "inputTime");
            return (Criteria) this;
        }

        public Criteria andInputTimeGreaterThan(Date value) {
            addCriterion("INPUT_TIME >", value, "inputTime");
            return (Criteria) this;
        }

        public Criteria andInputTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("INPUT_TIME >=", value, "inputTime");
            return (Criteria) this;
        }

        public Criteria andInputTimeLessThan(Date value) {
            addCriterion("INPUT_TIME <", value, "inputTime");
            return (Criteria) this;
        }

        public Criteria andInputTimeLessThanOrEqualTo(Date value) {
            addCriterion("INPUT_TIME <=", value, "inputTime");
            return (Criteria) this;
        }

        public Criteria andInputTimeIn(List<Date> values) {
            addCriterion("INPUT_TIME in", values, "inputTime");
            return (Criteria) this;
        }

        public Criteria andInputTimeNotIn(List<Date> values) {
            addCriterion("INPUT_TIME not in", values, "inputTime");
            return (Criteria) this;
        }

        public Criteria andInputTimeBetween(Date value1, Date value2) {
            addCriterion("INPUT_TIME between", value1, value2, "inputTime");
            return (Criteria) this;
        }

        public Criteria andInputTimeNotBetween(Date value1, Date value2) {
            addCriterion("INPUT_TIME not between", value1, value2, "inputTime");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNull() {
            addCriterion("USE_STATE is null");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNotNull() {
            addCriterion("USE_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andUseStateEqualTo(String value) {
            addCriterion("USE_STATE =", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotEqualTo(String value) {
            addCriterion("USE_STATE <>", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThan(String value) {
            addCriterion("USE_STATE >", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThanOrEqualTo(String value) {
            addCriterion("USE_STATE >=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThan(String value) {
            addCriterion("USE_STATE <", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThanOrEqualTo(String value) {
            addCriterion("USE_STATE <=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLike(String value) {
            addCriterion("USE_STATE like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotLike(String value) {
            addCriterion("USE_STATE not like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateIn(List<String> values) {
            addCriterion("USE_STATE in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotIn(List<String> values) {
            addCriterion("USE_STATE not in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateBetween(String value1, String value2) {
            addCriterion("USE_STATE between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotBetween(String value1, String value2) {
            addCriterion("USE_STATE not between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNull() {
            addCriterion("CREATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNotNull() {
            addCriterion("CREATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserEqualTo(String value) {
            addCriterion("CREATE_USER =", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotEqualTo(String value) {
            addCriterion("CREATE_USER <>", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThan(String value) {
            addCriterion("CREATE_USER >", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThanOrEqualTo(String value) {
            addCriterion("CREATE_USER >=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThan(String value) {
            addCriterion("CREATE_USER <", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThanOrEqualTo(String value) {
            addCriterion("CREATE_USER <=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLike(String value) {
            addCriterion("CREATE_USER like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotLike(String value) {
            addCriterion("CREATE_USER not like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserIn(List<String> values) {
            addCriterion("CREATE_USER in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotIn(List<String> values) {
            addCriterion("CREATE_USER not in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserBetween(String value1, String value2) {
            addCriterion("CREATE_USER between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotBetween(String value1, String value2) {
            addCriterion("CREATE_USER not between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNull() {
            addCriterion("UPDATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNotNull() {
            addCriterion("UPDATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserEqualTo(String value) {
            addCriterion("UPDATE_USER =", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotEqualTo(String value) {
            addCriterion("UPDATE_USER <>", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThan(String value) {
            addCriterion("UPDATE_USER >", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER >=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThan(String value) {
            addCriterion("UPDATE_USER <", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER <=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLike(String value) {
            addCriterion("UPDATE_USER like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotLike(String value) {
            addCriterion("UPDATE_USER not like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIn(List<String> values) {
            addCriterion("UPDATE_USER in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotIn(List<String> values) {
            addCriterion("UPDATE_USER not in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserBetween(String value1, String value2) {
            addCriterion("UPDATE_USER between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotBetween(String value1, String value2) {
            addCriterion("UPDATE_USER not between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("UPDATE_TIME =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("UPDATE_TIME <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("UPDATE_TIME >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("UPDATE_TIME <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("UPDATE_TIME in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("UPDATE_TIME not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("REMARK is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("REMARK is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("REMARK =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("REMARK <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("REMARK >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("REMARK >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("REMARK <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("REMARK <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("REMARK like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("REMARK not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("REMARK in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("REMARK not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("REMARK between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("REMARK not between", value1, value2, "remark");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}